# coding: utf-8

"""
    Modelmetry API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from modelmetry.openapi.models.completion_payload import CompletionPayload
from modelmetry.openapi.models.embeddings_payload import EmbeddingsPayload
from modelmetry.openapi.models.event import Event
from modelmetry.openapi.models.finding import Finding
from modelmetry.openapi.models.retrieval_payload import RetrievalPayload
from typing import Optional, Set
from typing_extensions import Self

class Span(BaseModel):
    """
    Span
    """ # noqa: E501
    completion: CompletionPayload = Field(alias="Completion")
    created_at: datetime = Field(alias="CreatedAt")
    embeddings: EmbeddingsPayload = Field(alias="Embeddings")
    end: datetime = Field(alias="End")
    events: List[Event] = Field(alias="Events")
    family: StrictStr = Field(alias="Family")
    findings: List[Finding] = Field(alias="Findings")
    id: StrictStr = Field(alias="ID")
    message: StrictStr = Field(alias="Message")
    metadata: Dict[str, Any] = Field(alias="Metadata")
    name: StrictStr = Field(alias="Name")
    other: Dict[str, Any] = Field(alias="Other")
    parent_id: StrictStr = Field(alias="ParentID")
    retrieval: RetrievalPayload = Field(alias="Retrieval")
    severity: StrictStr = Field(alias="Severity")
    start: datetime = Field(alias="Start")
    tenant_id: StrictStr = Field(alias="TenantID")
    trace_id: StrictStr = Field(alias="TraceID")
    updated_at: datetime = Field(alias="UpdatedAt")
    xid: StrictStr = Field(alias="XID")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["Completion", "CreatedAt", "Embeddings", "End", "Events", "Family", "Findings", "ID", "Message", "Metadata", "Name", "Other", "ParentID", "Retrieval", "Severity", "Start", "TenantID", "TraceID", "UpdatedAt", "XID"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Span from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of completion
        if self.completion:
            _dict['Completion'] = self.completion.to_dict()
        # override the default output from pydantic by calling `to_dict()` of embeddings
        if self.embeddings:
            _dict['Embeddings'] = self.embeddings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in events (list)
        _items = []
        if self.events:
            for _item in self.events:
                if _item:
                    _items.append(_item.to_dict())
            _dict['Events'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in findings (list)
        _items = []
        if self.findings:
            for _item in self.findings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['Findings'] = _items
        # override the default output from pydantic by calling `to_dict()` of retrieval
        if self.retrieval:
            _dict['Retrieval'] = self.retrieval.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Span from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Completion": CompletionPayload.from_dict(obj["Completion"]) if obj.get("Completion") is not None else None,
            "CreatedAt": obj.get("CreatedAt"),
            "Embeddings": EmbeddingsPayload.from_dict(obj["Embeddings"]) if obj.get("Embeddings") is not None else None,
            "End": obj.get("End"),
            "Events": [Event.from_dict(_item) for _item in obj["Events"]] if obj.get("Events") is not None else None,
            "Family": obj.get("Family"),
            "Findings": [Finding.from_dict(_item) for _item in obj["Findings"]] if obj.get("Findings") is not None else None,
            "ID": obj.get("ID"),
            "Message": obj.get("Message"),
            "Metadata": obj.get("Metadata"),
            "Name": obj.get("Name"),
            "Other": obj.get("Other"),
            "ParentID": obj.get("ParentID"),
            "Retrieval": RetrievalPayload.from_dict(obj["Retrieval"]) if obj.get("Retrieval") is not None else None,
            "Severity": obj.get("Severity"),
            "Start": obj.get("Start"),
            "TenantID": obj.get("TenantID"),
            "TraceID": obj.get("TraceID"),
            "UpdatedAt": obj.get("UpdatedAt"),
            "XID": obj.get("XID")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


